<?php 

function add_multiple_field() {
    echo '<table class="variations" cellspacing="0">
	      <tbody>
	          <tr>
		         <td class="label"><label for="color">Name On T-Shirt</label></td>
		         <td class="value">
		            <input type="text" name="properties[name-on-tshirt]" value="" />
		         </td>
		  	  </tr>	  
    		  <tr>
		         <td class="label"><label for="color">Name Font Color</label></td>
		         <td class="value">
		            <input type="text" name="properties[name-font-color]" value="" />
		         </td>
		  	  </tr>	  
			  <tr>
		         <td class="label"><label for="color">Name Font Size</label></td>
		         <td class="value">
		            <input type="text" name="properties[name-font-size]" value="" />
		         </td>
		  	  </tr>    		
	      </tbody>
	  </table>';
}
add_action( 'woocommerce_before_add_to_cart_button', 'add_multiple_field' );

function tshirt_name_validation() {
	$custom_fields = $_REQUEST['properties'];	
	if ( empty( $custom_fields['name-on-tshirt'] ) ) {
		wc_add_notice( __( 'Please enter a Name for Printing', 'woocommerce' ), 'error' );
		return false;
	}
	if ( empty( $custom_fields['name-font-color'] ) ) {
		wc_add_notice( __( 'Please enter the font Color', 'woocommerce' ), 'error' );
		return false;
	}
	if ( empty( $custom_fields['name-font-size'] ) ) {
		wc_add_notice( __( 'Please enter the font Size', 'woocommerce' ), 'error' );
		return false;
	}
	return true;
}
add_action( 'woocommerce_add_to_cart_validation', 'tshirt_name_validation', 1, 5 );


function save_custom_field_in_session( $cart_item_key, $product_id = null, $quantity= null, $variation_id= null, $variation= null ) {
	
	WC()->session->set( $cart_item_key.'_custom_fields_data', $_REQUEST['properties'] );
	
}
add_action( 'woocommerce_add_to_cart', 'save_custom_field_in_session', 1, 5 );


function render_meta_on_cart_item( $title = null, $cart_item = null, $cart_item_key = null ) {
	if( $cart_item_key && is_cart() ) {
		$custom_fields = WC()->session->get( $cart_item_key.'_custom_fields_data' );
		echo $title. '<dl class="">
				 		<dt class="">Name On T-Shirt : </dt>
				 		<dd class=""><p>'. $custom_fields['name-on-tshirt'] .'</p></dd>
			  		</dl>
				 	<dl class="">
				 		<dt class="">Name Font Color : </dt>
				 		<dd class=""><p>'. $custom_fields['name-font-color'] .'</p></dd>
			  		</dl>
				 	<dl class="">
				 		<dt class="">Name Font Size : </dt>
				 		<dd class=""><p>'. $custom_fields['name-font-size'] .'</p></dd>
			  		</dl>';
	}else {
		echo $title;
	}
}
add_filter( 'woocommerce_cart_item_name', 'render_meta_on_cart_item', 1, 3 );


function render_meta_on_checkout_order_review_item( $quantity = null, $cart_item = null, $cart_item_key = null ) {
	if( $cart_item_key ) {
		$custom_fields = WC()->session->get( $cart_item_key.'_custom_fields_data' );
		echo $quantity. '<dl class="">
					 		<dt class="">Name On T-Shirt : </dt>
					 		<dd class=""><p>'. $custom_fields['name-on-tshirt'] .'</p></dd>
				  		</dl>
					 	<dl class="">
					 		<dt class="">Name Font Color : </dt>
					 		<dd class=""><p>'. $custom_fields['name-font-color'] .'</p></dd>
				  		</dl>
					 	<dl class="">
					 		<dt class="">Name Font Size : </dt>
					 		<dd class=""><p>'. $custom_fields['name-font-size'] .'</p></dd>
				  		</dl>';
	}
}
add_filter( 'woocommerce_checkout_cart_item_quantity', 'render_meta_on_checkout_order_review_item', 1, 3 );


function tshirt_order_meta_handler( $item_id, $values, $cart_item_key ) {
	$custom_fields = WC()->session->get( $cart_item_key.'_custom_fields_data' );
	wc_add_order_item_meta( $item_id, "name_on_tshirt", $custom_fields['name-on-tshirt'] );
	wc_add_order_item_meta( $item_id, "name_font_color", $custom_fields['name-font-color'] );
	wc_add_order_item_meta( $item_id, "name_font_size", $custom_fields['name-font-size'] );
}
add_action( 'woocommerce_add_order_item_meta', 'tshirt_order_meta_handler', 1, 3 );


function tshirt_force_individual_cart_items($cart_item_data, $product_id) {
	$unique_cart_item_key = md5( microtime().rand() );
	$cart_item_data['unique_key'] = $unique_cart_item_key;

	return $cart_item_data;
}
add_filter( 'woocommerce_add_cart_item_data','tshirt_force_individual_cart_items', 10, 2 );

?>
